<?php
if ( ! class_exists( 'Magazine_News_Agency_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Magazine_News_Agency_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Magazine_News_Agency_Plugin_Activation_WPElemento_Importer {

        private static $magazine_news_agency_instance;
        public $magazine_news_agency_action_count;
        public $magazine_news_agency_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$magazine_news_agency_instance) ) {
            self::$magazine_news_agency_instance = new self();
          }
          return self::$magazine_news_agency_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'magazine_news_agency_recommended_plugins', array($this, 'magazine_news_agency_recommended_elemento_importer_plugins_array') );

            $magazine_news_agency_actions                   = $this->magazine_news_agency_get_recommended_actions();
            $this->magazine_news_agency_action_count        = $magazine_news_agency_actions['count'];
            $this->magazine_news_agency_recommended_actions = $magazine_news_agency_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function magazine_news_agency_recommended_elemento_importer_plugins_array($magazine_news_agency_plugins){
            $magazine_news_agency_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'magazine-news-agency'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'magazine-news-agency'),               
            );
            return $magazine_news_agency_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'magazine-news-agency-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('magazine-news-agency-plugin-activation-script', 'magazine_news_agency_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'magazine-news-agency'),
                    'activating' => esc_html__('Activating', 'magazine-news-agency'),
                    'error' => esc_html__('Error', 'magazine-news-agency'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'magazine-news-agency-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function magazine_news_agency_get_recommended_actions() {

            $magazine_news_agency_act_count  = 0;
            $magazine_news_agency_actions_todo = get_option( 'recommending_actions', array());

            $magazine_news_agency_plugins = $this->magazine_news_agency_get_recommended_plugins();

            if ($magazine_news_agency_plugins) {
                foreach ($magazine_news_agency_plugins as $magazine_news_agency_key => $magazine_news_agency_plugin) {
                    $magazine_news_agency_action = array();
                    if (!isset($magazine_news_agency_plugin['slug'])) {
                        continue;
                    }

                    $magazine_news_agency_action['id']   = 'install_' . $magazine_news_agency_plugin['slug'];
                    $magazine_news_agency_action['desc'] = '';
                    if (isset($magazine_news_agency_plugin['desc'])) {
                        $magazine_news_agency_action['desc'] = $magazine_news_agency_plugin['desc'];
                    }

                    $magazine_news_agency_action['name'] = '';
                    if (isset($magazine_news_agency_plugin['name'])) {
                        $magazine_news_agency_action['title'] = $magazine_news_agency_plugin['name'];
                    }

                    $magazine_news_agency_link_and_is_done  = $this->magazine_news_agency_get_plugin_buttion($magazine_news_agency_plugin['slug'], $magazine_news_agency_plugin['name'], $magazine_news_agency_plugin['function']);
                    $magazine_news_agency_action['link']    = $magazine_news_agency_link_and_is_done['button'];
                    $magazine_news_agency_action['is_done'] = $magazine_news_agency_link_and_is_done['done'];
                    if (!$magazine_news_agency_action['is_done'] && (!isset($magazine_news_agency_actions_todo[$magazine_news_agency_action['id']]) || !$magazine_news_agency_actions_todo[$magazine_news_agency_action['id']])) {
                        $magazine_news_agency_act_count++;
                    }
                    $magazine_news_agency_recommended_actions[] = $magazine_news_agency_action;
                    $magazine_news_agency_actions_todo[]        = array('id' => $magazine_news_agency_action['id'], 'watch' => true);
                }
                return array('count' => $magazine_news_agency_act_count, 'actions' => $magazine_news_agency_recommended_actions);
            }

        }

        public function magazine_news_agency_get_recommended_plugins() {

            $magazine_news_agency_plugins = apply_filters('magazine_news_agency_recommended_plugins', array());
            return $magazine_news_agency_plugins;
        }

        public function magazine_news_agency_get_plugin_buttion($slug, $name, $function) {
                $magazine_news_agency_is_done      = false;
                $magazine_news_agency_button_html  = '';
                $magazine_news_agency_is_installed = $this->is_plugin_installed($slug);
                $magazine_news_agency_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $magazine_news_agency_is_activeted = (class_exists($function)) ? true : false;
                if (!$magazine_news_agency_is_installed) {
                    $magazine_news_agency_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $magazine_news_agency_plugin_install_url = wp_nonce_url($magazine_news_agency_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $magazine_news_agency_button_html        = sprintf('<a class="magazine-news-agency-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($magazine_news_agency_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'magazine-news-agency'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'magazine-news-agency')
                    );
                } elseif ($magazine_news_agency_is_installed && !$magazine_news_agency_is_activeted) {

                    $magazine_news_agency_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($magazine_news_agency_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $magazine_news_agency_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $magazine_news_agency_button_html = sprintf('<a class="magazine-news-agency-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($magazine_news_agency_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'magazine-news-agency'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'magazine-news-agency')
                    );
                } elseif ($magazine_news_agency_is_activeted) {
                    $magazine_news_agency_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'magazine-news-agency'));
                    $magazine_news_agency_is_done     = true;
                }

                return array('done' => $magazine_news_agency_is_done, 'button' => $magazine_news_agency_button_html);
            }
        public function is_plugin_installed($slug) {
            $magazine_news_agency_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $magazine_news_agency_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($magazine_news_agency_installed_plugins[$magazine_news_agency_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $magazine_news_agency_keys = array_keys($this->get_installed_plugins());
            foreach ($magazine_news_agency_keys as $magazine_news_agency_key) {
                if (preg_match('|^' . $slug . '/|', $magazine_news_agency_key)) {
                    return $magazine_news_agency_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Magazine_News_Agency_Plugin_Activation_WPElemento_Importer::get_instance();